/*****************************************************************************
Rockland - Gestore dei font
*****************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL.h>
#include <SDL_opengl.h>
#include "font-engine.h"
#include "textures.h"

GLuint	font_tex;

// inizializza il motore dei font
int font_init(void)
{
	fprintf(stderr, "Inizializzo il gestore dei font...");
	font_tex = LoadTexture("textures/font.bmp", ALPHAMODE_RED, GL_LINEAR);
	if (font_tex == 0) {
		fprintf(stderr, " non posso caricare la texture dei caratteri!\n");
		return 1;
	}
	fprintf(stderr, " fatto\n");
	return 0;
}

// disegna una stringa utilizzando OpenGL e la texture del font
void font_drawstring(char *s, int x, int y)
{
	char	c;
	GLfloat	ofs = (1.0 / FONT_CHARS_PER_ROW);
	int	font_incr = (FONT_CHAR_W / FONT_SCALE);

	if (!font_tex)
		return;
	glBindTexture(GL_TEXTURE_2D, font_tex);
	// passa tutti i caratteri della stringa
	while ((c = *s++) != 0) {
		int	cell_x, cell_y;
		GLfloat	tex_top, tex_left;
		GLfloat	inc2;

		// evitiamo i caratteri non-ascii ;-)
		if (c <= ' ') {
			x += font_incr - 4;
			continue;
		}
		// calcola il riquadro della texture che contiene
		// l'immagine di questo carattere
		cell_x = (int)(c - ' ') % FONT_CHARS_PER_ROW;
		cell_y = (int)(c - ' ') / FONT_CHARS_PER_ROW;
		tex_left = (float)cell_x / FONT_CHARS_PER_ROW;
		tex_top = (float)cell_y / FONT_CHARS_PER_COL;
		// renderizza un quadrato con la porzione di texture desiderata
		inc2 = font_incr;
		glBegin(GL_QUADS);
		glTexCoord2f(tex_left, tex_top);		glVertex3f(x, y, 0.0);
		glTexCoord2f(tex_left+ofs, tex_top);		glVertex3f(x+inc2, y, 0.0);
		glTexCoord2f(tex_left+ofs, tex_top+ofs);	glVertex3f(x+inc2, y+inc2, 0.0);
		glTexCoord2f(tex_left, tex_top+ofs);		glVertex3f(x, y+inc2, 0.0);
		glEnd();
		x += font_incr - 4;
	}
}

