/********************************************************************************
Rockland
2001-oo Tito Dal Canton
	Funzioni di interfaccia con il layer di input di SDL
********************************************************************************/
#include <SDL.h>
#include "global.h"
#include "main-menu.h"
#include "rocklandinput.h"

extern int	gDone;
extern int	gScreenWidth, gScreenHeight;
extern int	gDisplayFlags;

// ottieni gli eventi che ci interessano
void QueryEvents(RocklandEventData *eventData)
{
	int			mx, my, dx, dy;
	int			buttons;
	SDL_Event	event;

	// leggi lo spostamento del mouse
	buttons = SDL_GetRelativeMouseState(&dx, &dy);
	eventData->rotationDelta = (float)dx * 0.02;
	eventData->elevationDelta = (float)dy * 0.01;
	// se il puntatore esce dallo schermo la rotazione si blocca,
	// quindi dobbiamo farlo rientrare dall'altra parte per garantire
	// una rotazione continua. Che palle :)
	SDL_GetMouseState(&mx, &my);
	if (mx <= 0) {		
		SDL_WarpMouse(gScreenWidth-2, my);
		SDL_PumpEvents();	// cancella l'evento causato da WarpMouse
		SDL_GetRelativeMouseState(&dx, &dy);
		mx = gScreenWidth-2;
	} else if (mx >= gScreenWidth-1) {
		SDL_WarpMouse(1, my);
		SDL_PumpEvents();	// cancella l'evento causato da WarpMouse
		SDL_GetRelativeMouseState(&dx, &dy);
		my = 1;
	}
	if (my <= 0) {
		SDL_WarpMouse(mx, gScreenHeight-2);
		SDL_PumpEvents();   // cancella l'evento causato da WarpMouse
		SDL_GetRelativeMouseState(&dx, &dy);
		my = gScreenHeight-2;
	} else if (my >= gScreenHeight-1) {
		SDL_WarpMouse(mx, 1);
		SDL_PumpEvents();   // cancella l'evento causato da WarpMouse
		SDL_GetRelativeMouseState(&dx, &dy);
		my = 1;
	}
	eventData->fire = buttons & SDL_BUTTON(1);
	
	event.type = SDL_NOEVENT;
	eventData->quit = 0;
	eventData->fwd = 0;
	eventData->bwd = 0;
	eventData->action = 0;
	
	// leggi lo stato della tastiera
	while (SDL_PollEvent(&event)) {
		switch (event.type) {
			case SDL_KEYDOWN:
				switch (event.key.keysym.sym) {
					case SDLK_ESCAPE:	eventData->quit = 1;	break;
					case SDLK_UP:		eventData->fwd = 1;		break;
					case SDLK_DOWN:		eventData->bwd = 1;		break;
					case SDLK_LEFT:		eventData->rotationDelta = -0.4;	break;
					case SDLK_RIGHT:	eventData->rotationDelta = +0.4;	break;
					default:			break;
				}
				break;
			case SDL_KEYUP:
				switch (event.key.keysym.sym) {
					case SDLK_i:
						if (gDisplayFlags & SHOW_INFO)
							gDisplayFlags &= ~SHOW_INFO;
						else
							gDisplayFlags |= SHOW_INFO;
						break;
					case SDLK_RETURN:
						eventData->action = 1;
						break;
					default:		break;
				}
				break;
			case SDL_QUIT:
				eventData->quit = 1;
				break;
			default:
				break;
		}
	}
}

