/********************************************************************************
Rockland
1999-oo Tito Dal Canton
	Non penso che questo file abbia bisogno di commenti... qua si gestiscono
	tutti gli aspetti del menu principale, preferenze eccetera eccetera. 2 palle.
********************************************************************************/
#include <stdio.h>
#include <SDL.h>
#include <SDL_image.h>
#include <math.h>
#include "main-menu.h"
#include "rocklandinput.h"

static int PtInRect(int x, int y, SDL_Rect *r);

extern int			gScreenWidth, gScreenHeight;
extern SDL_Surface	*main_surface;
SDL_Surface			*gImages[4][2];
SDL_Rect			gImageRects[4], gTitleRect;
SDL_Surface			*gTitleImage = NULL;

void DrawMainMenu(int fadeIn)
{
	int			j;

	ClearScreenToBlack();
	if (gTitleImage == NULL) {
		gTitleImage = IMG_Load("gui/title.jpg");
		if (gTitleImage == NULL) {
			fprintf(stderr, "title.bmp, caricamento fallito (%s)\n", SDL_GetError());
			return;
		}
		gTitleRect.w = gTitleImage->w;
		gTitleRect.h = gTitleImage->h;
		gTitleRect.x = gScreenWidth  - gTitleRect.w - 20;
		gTitleRect.y = (gScreenHeight / 2) - (gTitleRect.h / 2);
	}
	SDL_BlitSurface(gTitleImage, NULL, main_surface, &gTitleRect);
	SDL_UpdateRects(main_surface, 1, &gTitleRect);

	for (j = 0; j < 4; j++) {
		if (gImages[j][0] == NULL) {
			SDL_Rect	butRect;
			char		str[256] = "", str2[256] = "";
			
			sprintf(str, "gui/button%d.jpg", j);
			sprintf(str2, "gui/button%d-hi.jpg", j);
			gImages[j][0] = IMG_Load(str);
			gImages[j][1] = IMG_Load(str2);
			if (gImages[j][0] == NULL) {
				fprintf(stderr, "%s, caricamento fallito (%s)\n", str, SDL_GetError());
				return;
			}
			butRect.w = gImages[j][0]->w;
			butRect.h = gImages[j][0]->h;
			butRect.x = 0;
			butRect.y = (480 / 4) * j + (gScreenHeight / 2) - 240 + 20; 
			gImageRects[j] = butRect;
		}
		SDL_BlitSurface(gImages[j][0], NULL, main_surface, &gImageRects[j]);
		SDL_UpdateRects(main_surface, 1, &gImageRects[j]);
	}
	SDL_GL_SwapBuffers();
}

int DoMainMenu(void)
{
	int		x, y, j;

	do {
		while (!(SDL_GetMouseState(&x, &y) & SDL_BUTTON(1))) {
			SDL_PumpEvents();
			for (j = 0; j < 4; j++) {
				if (PtInRect(x, y, &gImageRects[j]))
					SDL_BlitSurface(gImages[j][1], NULL, main_surface, &gImageRects[j]);
				else
					SDL_BlitSurface(gImages[j][0], NULL, main_surface, &gImageRects[j]);
				SDL_UpdateRects(main_surface, 1, &gImageRects[j]);
			}
			SDL_GL_SwapBuffers();
			SDL_Delay(10);
		}
		while ((SDL_GetMouseState(&x, &y) & SDL_BUTTON(1)))
			SDL_PumpEvents();
		
		if (PtInRect(x, y, &gImageRects[0])) {	// explore
			ClearScreenToBlack();
			return 1;
		}
		if (PtInRect(x, y, &gImageRects[1]))	// edit options
			return 3;
		if (PtInRect(x, y, &gImageRects[2]))	// about
			return 3;
		if (PtInRect(x, y, &gImageRects[3]))	// quit
			return 3;
	} while (1);
}

void ClearScreenToBlack(void)
{
	SDL_FillRect(main_surface, NULL, SDL_MapRGB(main_surface->format, 0, 0, 0));
	SDL_UpdateRect(main_surface, 0, 0, gScreenWidth, gScreenHeight);
}

static int PtInRect(int x, int y, SDL_Rect *r)
{
	if (x < r->x || y < r->y)
		return 0;
	if (x >= (r->x + r->w) || y >= (r->y + r->h))
		return 0;
	return 1;
}

