#include <Resources.h>
#include <Sound.h>
#include <Dialogs.h>
#include <NumberFormatting.h>
#include "rocklandsound.h"

void OSError(OSStatus e, unsigned char *addMsg);

#define RangedRand(max)				(((Random() + 32768) / 65536.0) * max)

SndChannelPtr	gMainChan = NULL;
SndChannelPtr	gAmbientChan = NULL;
extern	Boolean	gDone;

SndListHandle	gSfxThunder[3];
Handle			wind;

void InitSoundStuff(void)
{
	OSStatus		err = noErr;
	SndCommand		mySndCmd;
	long			offset;
	
	err = SndNewChannel(&gMainChan, sampledSynth, initStereo, nil);
	if (err != noErr)
		goto bail;
	err = SndNewChannel(&gAmbientChan, sampledSynth, initStereo, nil);
	if (err != noErr)
		goto bail;
	
	wind = GetResource('snd ', 200);
	if (wind == nil)
		OSError(0, "\p (Risorsa snd non trovata)");
	DetachResource((Handle)wind);
	HLock((Handle)wind);
	
	return;
bail:
	gDone = true;
}

void PlaySoundFX(void)
{
	long	sound;
	
	sound = RangedRand(2.8);
	SndPlay(gMainChan, gSfxThunder[sound], true);
}

void StartWind(void)
{
	OSStatus		err = noErr;
	SndCommand		mySndCmd;
	long			offset;
	
	GetSoundHeaderOffset((SndListHandle)wind, &offset);	// get offset to header
	
	mySndCmd.cmd = soundCmd;							// install sample in the channel
	mySndCmd.param1 = 0;
	mySndCmd.param2 = (long)((*wind) + offset);	// pointer to SoundHeader
	if (err = SndDoImmediate(gAmbientChan, &mySndCmd))
		OSError(err, "\p, soundCmd");

	mySndCmd.cmd = freqCmd;								// call this to START sound & keep looping 
	mySndCmd.param1 = 0;
	mySndCmd.param2 = 50;								// MIDI freq
	if (err = SndDoImmediate(gAmbientChan, &mySndCmd))
		OSError(err, "\p, freqCmd");
}

void CleanupSound(void)
{
	SndCommand	mySndCmd;
	
	mySndCmd.cmd = quietCmd;								
	mySndCmd.param1 = 0;
	mySndCmd.param2 = 0;
	SndDoImmediate(gAmbientChan, &mySndCmd);
}

void OSError(OSStatus e, unsigned char *addMsg)
{
	Str255	s;
	
	NumToString(e, s);
	ParamText(s, addMsg, "\p", "\p");
	Alert(177, nil);
}